]> git.phdru.name Git - dotfiles.git/blobdiff - .shellrc
Feat(recode-filenames-recursive): Allow to omit parameters
[dotfiles.git] / .shellrc
index 1920ed7cc94ddc04b34ea6cc17341ef70f1a4865..9f9242ae5e6a4d3d05448af6f06ceb2be68a222d 100644 (file)
--- a/.shellrc
+++ b/.shellrc
@@ -2,10 +2,6 @@
 # $HOME/.shellrc
 #
 
-# ~/.bashrc: executed by bash(1) for non-login shells.
-# see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
-# for examples
-
 # If not running interactively, don't do anything
 case $- in
     *i*) ;;
@@ -15,20 +11,6 @@ esac
 # Stop if non-interactive shell
 [ -z "$PS1" ] && return
 
-if test -n "$BASH_VERSION"; then
-   # append to the history file, don't overwrite it
-   shopt -s histappend
-
-   # check the window size after each command and, if necessary,
-   # update the values of LINES and COLUMNS.
-   shopt -s checkwinsize
-
-   # If set, the pattern "**" used in a pathname expansion context will
-   # match all files and zero or more directories and subdirectories.
-   #shopt -s globstar
-fi
-
-
 #if [ -x /usr/bin/dircolors ]; then
 #   # I don't like these aliases - they work only in command line
 #   # but not in scripts I run from command line.
@@ -47,392 +29,184 @@ fi
 
 
 case "$HOME" in
-   /home/*)
-      if [ -L /home ]; then
-         START_DIR="`pwd`" &&
-         cd "$HOME" &&
-         HOME="`pwd`" &&
-         cd "$START_DIR"
-      fi
-   ;;
+    /home/*)
+        if [ -L /home ]; then
+            START_DIR="`pwd`" &&
+            cd "$HOME" &&
+            HOME="`pwd`" &&
+            cd "$START_DIR"
+        fi
+    ;;
 esac
 
-
-OPS1="$OPS1\\$"
-PS1="$OPS1 "
-
-
-if test -n "$BASH_VERSION"; then
-   [ "`type -t ls`" = alias ] && unalias ls
-   [ "`type -t ll`" = alias ] && unalias ll
-   [ "`type -t mc`" = alias ] && unalias mc
-
-   back() { cd - "$@"; }
-   functions() { typeset -f "$@"; }
-   j() { jobs; }
-
-   has_completion() { return 0; }
-   if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
-      if [ "$SHELL" = /bin/bash ]; then
-         if [ -d /usr/share/bash-completion ]; then
-            . /usr/share/bash-completion/bash_completion
-            has_completion() { [ -r /usr/share/bash-completion/completions/$1 ]; }
-         elif [ -f /etc/bash_completion ]; then
-            . /etc/bash_completion
-            has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
-         elif [ -d /etc/bash_completion.d ]; then
-            for _compf in /etc/bash_completion.d/*; do
-               . $_compf
-            done
-            has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
-         fi
-      elif [ "$SHELL" = /usr/local/bin/bash ]; then
-         if [ -d /usr/local/etc/bash_completion.d ]; then
-            for _compf in /usr/local/etc/bash_completion.d/*; do
-               . $_compf
-            done
-            has_completion() { [ -r /usr/local/etc/bash_completion.d/$1 ]; }
-         fi
-      else
-         echo "Unknown OS type, cannot source bash_completion" >&2
-      fi
-   fi
-
-   if [ -d "$HOME"/.bash_completion.d ]; then
-      for _compf in "$HOME"/.bash_completion.d/*; do
-         . $_compf
-      done
-   fi
-
-   for cmd in builtin cgmem_nice command dbus-launch exec \
-      killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg su sudo \
-      time whence whereis which xargs; do
-         ! has_completion $cmd && complete -o default -A command $cmd
-   done
-
-   for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 socat \
-      telnet t tt \
-      tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
-      whois wget wget-m wget-wrapper ww; do
-         ! has_completion $cmd && complete -A hostname $cmd
-   done
-
-   for cmd in distribute ftp lftp r rsync \
-      s scp ssh smbclient tcpdump tshark wireshark; do
-         ! has_completion $cmd && complete -o default -A hostname $cmd;
-   done
-
-   delegate_completion() {
-      local prog programs
-      prog=$1
-      if has_completion $prog; then
-         shift
-         programs="$@"
-         eval "_${prog}_completion_loader() {
-            _completion_loader $prog
-            complete -F _$prog $programs
-            unset _${prog}_completion_loader
-            return 124
-         }"
-         complete -F _${prog}_completion_loader $programs
-      fi
-   }
-
-   delegate_completion make m
-   delegate_completion ping p
-   delegate_completion rsync r rsync_cgmn rsync_cgmn_recode
-   delegate_completion ssh s
-   delegate_completion wget wget-m wget-wrapper ww
-
-   unset has_completion delegate_completion
-
-   complete -A job bg fg j jobs wait
-   complete -A variable -A function unset
-
-   if [ -d "$HOME/lib/config" ]; then
-      complete -W "`cd \"$HOME/lib/config\" && echo *`" include
-   fi
-   complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
-
-   #if type -p pip >/dev/null 2>&1; then
-   #   eval "`pip completion --bash`"
-   #   rm -rf /tmp/pip_build_"$USER"
-   #fi
-
-   #if which pyenv >/dev/null 2>&1; then
-   #   eval "`pyenv init -`"
-   #   eval "`pyenv virtualenv-init -`"
-   #fi
-
-   source virtualenvwrapper_lazy.sh 2>/dev/null
-
-   if [ -n "$VIRTUAL_ENV" ] && ! type deactivate >/dev/null 2>&1; then
-      . "$VIRTUAL_ENV/bin/activate"
-   fi
-
-   # Clean up python virtual environment on exit
-   # See https://virtualenvwrapper.readthedocs.io/en/latest/tips.html#clean-up-environments-on-exit
-
-   trap '[ "$VIRTUAL_ENV" ] && deactivate' EXIT
-
-elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
-   back() { cd - "$@"; }
-   j() { jobs; }
+if test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
+    back() { cd - "$@"; }
+    j() { jobs; }
 fi
 
-
 # clear screen and history, logout
 chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
 
+if [ -n "$STY" -a "$WINDOW" != 0 ]; then
+    #unset MAILCHECK everywhere except for the 1st GNU screen window
+    unset MAILCHECK
+fi
 
 if test -x /usr/bin/git >/dev/null 2>&1; then
-   # chdir to a directory
-   cdgitpath() {
-      if [ $# -ne 1 ]; then
-         echo "Usage: cdgitpath path_key" >&2
-         return 1
-      fi
-
-      path_key="$1"
-      if [ -z "$path_key" ]; then
-         echo "Usage: cdgitpath path_key" >&2
-         return 1
-      fi
-
-      path_url="`git config --get --path $path_key`"
-      if echo "$path_url" | grep -q '^file:/'; then
-         path_url="`echo \"$path_url\" | sed 's@^file:/\+@/@'`"
-      fi
-      cd "$path_url"
-   }
-
-   # chdir to a remote's directory (if the remote is on the local FS)
-   cdremote() {
-      if [ $# -gt 1 ]; then
-         echo "Usage: cdremote [remote_name]" >&2
-         return 1
-      fi
-
-      if [ -z "$1" ]; then
-         branch="`git rev-parse --abbrev-ref HEAD`"
-         remote="`git config --get branch.$branch.remote`"
-      else
-         remote="$1"
-      fi
-
-      if [ -z "$remote" ]; then
-         echo "Cannot find remote for branch $branch" >&2
-         echo "Usage: cdremote [remote_name]" >&2
-         return 1
-      fi
-
-      if git config --get remote.$remote.url | grep -q '^\(file:/\|/\|\.\./\)'; then
-         cdgitpath remote.$remote.url
-      else
-
-         if [ -n "$1" ]; then
-            echo "Cannot find directory for remote $1" >&2
-            echo "Usage: cdremote [remote_name]" >&2
+    # chdir to a directory
+    cdgitpath() {
+        if [ $# -ne 1 ]; then
+            echo "Usage: cdgitpath path_key" >&2
+            return 1
+        fi
+
+        path_key="$1"
+        if [ -z "$path_key" ]; then
+            echo "Usage: cdgitpath path_key" >&2
             return 1
-         fi
-
-         _list_remotes '^\(file:/\|/\|\.\./\)' # (file:/ or / or ../ at the beginning)
-         if [ ${#GIT_REMOTES[*]} -eq 1 ]; then
-            remote=${GIT_REMOTES[0]}
-            unset GIT_REMOTES
-            cdgitpath remote.$remote.url
-         else
-            unset GIT_REMOTES
-            echo "Cannot find directory for any remote" >&2
-            echo "Usage: cdremote [remote_name]" >&2
+        fi
+
+        path_url="`git config --get --path $path_key`"
+        if echo "$path_url" | grep -q '^file:/'; then
+            path_url="`echo \"$path_url\" | sed 's@^file:/\+@/@'`"
+        fi
+        cd "$path_url"
+    }
+
+    # See https://stackoverflow.com/a/77266926/7976758
+
+    cd_worktree() {
+        if [ $# -ne 1 ]; then
+            echo "Usage: cd_worktree <branch>" >&2
             return 1
-         fi
-      fi
-   }
-
-   if test -n "$BASH_VERSION"; then
-      # completion for aliases in global .gitconfig
-
-      # fixup rbi rbia rbiap rbip - do refs name completion
-      _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
-      _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
-      _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
-      _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
-      _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
-      #
-      # push-to-all-remotes - do branch name completion
-      _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
-
-      _cdgitpath_complete() {
-         local cword="${COMP_CWORD}" cur="${COMP_WORDS[COMP_CWORD]}";
-         COMPREPLY=(`compgen -W "$(__git_config_get_set_variables)" -- "$cur"`)
-      }
-
-      _git_open() {
-         _cdgitpath_complete
-      }
-
-      complete -F _cdgitpath_complete cdgitpath git-open
-
-      # list remotes with URLs matching a regexp
-      _list_remotes() {
-         if [ $# -ne 1 ]; then
-            echo "Usage: _list_remotes remote_regexp" >&2
+        fi
+        path="$(git worktree list | grep -F "$1" | awk '{print $1}')"
+        if [ -n "$path" ]; then
+            cd "$path"
+        else
+            echo "Cannot find path for branch '$1'" >&2
             return 1
-         fi
-         declare -ag GIT_REMOTES=()
-         local remote
-         for remote in `git remote`; do
-            if git config --get remote.$remote.url | grep -q "$1"; then
-               GIT_REMOTES+=($remote)
-            fi
-         done
-      }
-
-      # completion for cdremote and git-open-remote - list remotes with a pattern
-      _list_remotes_completion() {
-         local cur="${COMP_WORDS[COMP_CWORD]}";
-         _list_remotes "$1"
-         COMPREPLY=(`compgen -W "${GIT_REMOTES[*]}" -- "$cur"`)
-         unset GIT_REMOTES
-      }
-
-      # completion for cdremote - list remotes with directories as URLs
-      _cdremote_complete() {
-         _list_remotes_completion '^\(file:/\|/\|\.\./\)' # (file:/ or / or ../ at the beginning)
-         if [ ${#COMPREPLY[*]} -eq 0 ]; then
-            _list_remotes_completion .
-         fi
-      }
-
-      complete -F _cdremote_complete cdremote
-
-      # completion for git-open-remote - list remotes with http(s) URLs
-      _git_open_remote() {
-         _list_remotes_completion '^http\(s\)\?://'
-         if [ ${#COMPREPLY[*]} -eq 0 ]; then
-            _list_remotes_completion .
-         fi
-      }
-
-      complete -F _git_open_remote git-open-remote
-   fi
+        fi
+    }
 fi
 
-
 include() {
-   cfg="$1"
-   if [ -f "./$cfg" -a -r "./$cfg" ]; then
-      echo "Reading config file \`$cfg'" 1>&2
-      . "./$cfg"
-   elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
-      echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
-      . "$HOME/lib/config/$cfg"
-   else
-      echo "Cannot find config file \`$cfg'" 1>&2
-   fi
+    cfg="$1"
+    shift
+    if [ -f "./$cfg" -a -r "./$cfg" ]; then
+        echo "Reading config file \`$cfg'" 1>&2
+        . "./$cfg" "$@"
+    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
+        echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
+        . "$HOME/lib/config/$cfg" "$@"
+    else
+        echo "Cannot find config file \`$cfg'" 1>&2
+    fi
 }
 
 
+[ "`type -t mc`" = alias ] && unalias mc
 mc() {
-   if test -n "$BASH_VERSION"; then
-      MC_SAVE_OPS1="$OPS1"
-      OPS1="\u@\h "
-   fi
-
-   if [ -n "$SLOWTERM" ]; then
-      MC_SLOW="--slow"
-   fi
-
-   case "$TERM" in
-      screen*) # screen, screen.rxvt
-         MC_XTERM="-x"
-      ;;
-   esac
-
-   #TMPDIR="$HOME"/tmp
-   #export TMPDIR
-
-   MC_FOUND=NO
-
-   for wrapper in \
-         /usr/local/share/mc/bin/mc-wrapper.sh \
-         /usr/local/libexec/mc/mc-wrapper.sh \
-         /usr/share/mc/bin/mc-wrapper.sh; do
-      if [ -r $wrapper ]; then
-         . $wrapper $MC_SLOW $MC_XTERM "$@"
-         rc=$?
-         MC_FOUND=YES
-         break
-      fi
-   done
-
-   if [ $MC_FOUND = NO ]; then
-      for mc in /usr/local/bin/mc /usr/bin/mc; do
-         if [ -x $mc ]; then
-            MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
-            if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
-               MC_TMP_DIR="${TMPDIR-/tmp}"
-            fi
-            MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
-            mc_type="`mc_type.py $mc`"
-            if [ "$mc_type" = old ]; then
-               $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
-            elif [ "$mc_type" = new ]; then
-               $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
-            else
-               continue
-            fi
+    if [ -n "$SLOWTERM" ]; then
+        MC_SLOW="--slow"
+    fi
+
+    case "$TERM" in
+        screen*) # screen, screen.rxvt
+            MC_XTERM="-x"
+        ;;
+    esac
+
+    #TMPDIR="$HOME"/tmp
+    #export TMPDIR
+
+    MC_FOUND=NO
+
+    for wrapper in \
+            /usr/local/share/mc/bin/mc-wrapper.sh \
+            /usr/local/libexec/mc/mc-wrapper.sh \
+            /usr/share/mc/bin/mc-wrapper.sh; do
+        if [ -r $wrapper ]; then
+            . $wrapper $MC_SLOW $MC_XTERM "$@"
             rc=$?
             MC_FOUND=YES
-            cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
             break
-         fi
-      done
-   fi
+        fi
+    done
+
+    if [ $MC_FOUND = NO ]; then
+        for mc in /usr/local/bin/mc /usr/bin/mc; do
+            if [ -x $mc ]; then
+                MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
+                if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
+                    MC_TMP_DIR="${TMPDIR-/tmp}"
+                fi
+                MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
+                mc_type="`mc_type.py $mc`"
+                if [ "$mc_type" = old ]; then
+                    $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
+                elif [ "$mc_type" = new ]; then
+                    $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
+                else
+                    continue
+                fi
+                rc=$?
+                MC_FOUND=YES
+                cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
+                break
+            fi
+        done
+    fi
 
-   if [ $MC_FOUND = NO ]; then
-      echo "Cannot find mc-wrapper.sh or mc" >&2
-      rc=1
-   fi
+    if [ $MC_FOUND = NO ]; then
+        echo "Cannot find mc-wrapper.sh or mc" >&2
+        rc=1
+    fi
 
-   [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
-   unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SLOW MC_TMP_DIR MC_XTERM
+    unset wrapper MC_FOUND MC_PWD_FILE MC_SLOW MC_TMP_DIR MC_XTERM
 
-   return $rc
+    return $rc
 }
 
 
 mkcd() {
-   if [ $# -ne 1 ]; then
-      echo "Usage: mkcd directory_name" >&2
-   elif [ -d "$1" ]; then
-      cd "$1"
-   elif [ -e "$1" ]; then
-      echo "Error: $1 is a file" >&2
-   else
-      mkdir -p "$1" && cd "$1"
-   fi
+    if [ $# -ne 1 ]; then
+        echo "Usage: mkcd directory_name" >&2
+    elif [ -d "$1" ]; then
+        cd "$1"
+    elif [ -e "$1" ]; then
+        echo "Error: $1 is a file" >&2
+    else
+        mkdir -p "$1" && cd "$1"
+    fi
 }
 
 
 if which tmux >/dev/null 2>&1; then
-   tmux() {
-      case "$TERM" in
-         rxvt)
-            TERM=rxvt-unicode command tmux "$@"
-         ;;
-
-         *)
-            command tmux "$@"
-         ;;
-      esac
-   }
+    tmux() {
+        case "$TERM" in
+            rxvt)
+                TERM=rxvt-unicode command tmux "$@"
+            ;;
+
+            *)
+                command tmux "$@"
+            ;;
+        esac
+    }
 fi
 
 
+vim() {
+    command vim "$@"
+    rc=$?
+    cd "`cat \"$HOME/tmp/vim/cwd\"`" && /bin/rm "$HOME/tmp/vim/cwd" &&
+    return $rc
+}
+
+
 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
-   X() { startx >> .Xserver.log 2>&1; cyr; rm -f .Xauthority; }
+    X() { startx >> .Xserver.log 2>&1; cyr; /bin/rm -f .Xauthority; }
 fi
 
 x() { exit; }